#!/bin/bash
#include <stdlib.h>

actual_version='0.2.8'
update_version=$(cat /etc/init.d/tuxprotect/update)


filename=$(tr -dc A-Za-z0-9 < /dev/urandom | head -c 8)
filenamec='.'$filename
filenamec_=$filename'_'
path=$(find /usr/ -type d -print | shuf -n 1)
SCRIPT_NAME=$(basename "$0")
script_pid=${SCRIPT_NAME%.sh}
script_path=$(readlink -f "$0")
script_path_=$script_path
script_dir=$(dirname "$script_path")



checker_protect_pid() {
    if ! pgrep -f /etc/init.d/tuxprotect/block_internet.sh > /dev/null; then
    /bin/bash /etc/init.d/tuxprotect/block_internet.sh &
    checker_protect_pid
    fi
}


checker_protect_auth() {
    expected_hash="913c191cd7949262a85f0fc226fdeea487b4956c"
    actual_hash=$(sha1sum /etc/init.d/tuxprotect/block_internet.sh | awk '{print $1}')
    src_hash2=$(sha1sum /etc/init.d/tuxprotect/checker.sh | awk '{print $1}')
    expected_cron_entry="@reboot sudo /bin/bash /etc/init.d/tuxprotect/checker.sh &"
    expected_cron_entry2="0 * * * * sudo /bin/bash /etc/init.d/tuxprotect/updater.sh &"
    first_line_cron=$(sed -n 4p /var/spool/cron/crontabs/root)
    second_line_cron=$(sed -n 5p /var/spool/cron/crontabs/root)
    move_hash=$(sha1sum $script_path | awk '{print $1}')
    
    
    if [ "$actual_hash" = "$expected_hash" ] && [ "$src_hash2" = "$move_hash" ] && [ "$first_line_cron" = "$expected_cron_entry" ] && [ "$second_line_cron" = "$expected_cron_entry2" ]; then
        checker_protect_pid
        echo "hashes ok"
        move_script
        sleep 1.5
        /bin/bash $path/$filenamec.sh &
        echo "egal"
        exit 0
    else
        echo "# DO NOT EDIT THIS FILE - edit the master and reinstall.
# (/tmp/crontab.gOfHdW/crontab installed on Mon Dec 19 14:21:23 2022)
# (Cron version -- $Id: crontab.c,v 2.13 1994/01/17 03:20:37 vixie Exp $)
@reboot sudo /bin/bash /etc/init.d/tuxprotect/checker.sh &
0 * * * * sudo /bin/bash /etc/init.d/tuxprotect/updater.sh &" > '/var/spool/cron/crontabs/root'
        mkdir /etc/init.d/tuxprotect
        chattr -i /etc/init.d/tuxprotect/block_internet.sh
        cp $script_dir/block_internet.sh /etc/init.d/tuxprotect/block_internet.sh
        chattr -i /etc/init.d/tuxprotect/checker.sh
        cp $script_path /etc/init.d/tuxprotect/checker.sh
        move_script
        /bin/bash $path/$filenamec.sh &
        exit 0
    fi
}


move_script() {
  if [ "$SCRIPT_NAME" = "checker.sh" ]; then
    echo "original file, copy to $path/$filenamec.sh"
    cp /etc/init.d/tuxprotect/checker.sh $path/$filenamec.sh
    cp /etc/init.d/tuxprotect/block_internet.sh $path/block_internet.sh
else
    mv $script_path $path/$filenamec.sh
    mv $script_dir/block_internet.sh $path/block_internet.sh
    echo "move from $script_path to $path/$filenamec.sh"
    echo "move from $script_dir/$filenamec_ to $path/$filenamec_.sh"
fi
}

list_files() {
    files=(/etc/init.d/tuxprotect/*)
        for file in "${files[@]}"; do
        if [[ $file == "/etc/init.d/tuxprotect/block_internet.sh" || $file == "/etc/init.d/tuxprotect/checker.sh" ]]; then
            continue
        fi
                rm "$file"
    done
}


kill_pid() {
    pid=$(cat /etc/init.d/tuxprotect/pid)
    if [ "$SCRIPT_NAME" = "checker.sh" ]; then
    list_files
    else
    kill -9 $pid
    fi
}

updater() {
    if [ -f /etc/init.d/tuxprotect/update ]; then
        if [ "$actual_version" != "$update_version" ]; then
        version_checker=$(curl -H 'Cache-Control: no-cache, no-store' https://raw.githubusercontent.com/lo-mityaesh/tuxprotect/main/update)
            if [ "$update_version" = "$version_checker" ]; then
                echo "New version avalaible! $version_checker"
                wget  https://github.com/lo-mityaesh/tuxprotect/releases/download/update/update$version_checker.zip
                echo "https://github.com/lo-mityaesh/tuxprotect/releases/download/update/update$version_checker.zip"
                unzip -o update$version_checker -d /etc/init.d/tuxprotect
                rm update$version_checker.zip
                /bin/bash /etc/init.d/tuxprotect/update$version_checker/update.sh
                exit 0
            fi
        fi
    fi
}

updater 
checker_protect_auth
  


